This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours
Bug 674007 - Review Request: openni-primesense - PrimeSensor/Kinect Modules for OpenNI
Review Request: openni-primesense - PrimeSensor/Kinect Modules for OpenNI
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Rich Mattes
Fedora Extras Quality Assurance
:
Depends On: 674006
Blocks:
  Show dependency treegraph
 
Reported: 2011-01-31 05:18 EST by Tim Niemueller
Modified: 2011-03-18 15:26 EDT (History)
3 users (show)

See Also:
Fixed In Version: openni-primesense-5.0.0.25-0.4.git894cea01.fc14
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2011-03-17 14:53:21 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
richmattes: fedora‑review+
tibbs: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Tim Niemueller 2011-01-31 05:18:14 EST
Spec URL: http://fedorapeople.org/~timn/robotics/openni-primesense.spec
SRPM URL: http://fedorapeople.org/~timn/robotics/openni-primesense-5.0.0.25-0.1_git894cea01.fc14.src.rpm
Project URL: http://www.openni.org and https://github.com/ros-pkg-git/Sensor
Description: This modules enables OpenNI to make use of the PrimeSense, also known as Kinect depth camera.

Koji: Possible only after openni has been accepted and is tagged into the build root

rpmlint: 
openni-primesense.spec: W: invalid-url Source0: openni-primesense-5.0.0.25-git894cea01.tar.gz
openni-primesense.src: W: invalid-url Source0: openni-primesense-5.0.0.25-git894cea01.tar.gz
- no tarballs are released, need to pull from git

openni-primesense.x86_64: W: incoherent-version-in-changelog 5.0.0.24-0.1gitc0e70ea1 ['5.0.0.25-0.1_git894cea01.fc14', '5.0.0.25-0.1_git894cea01']
- no dist tag in changelog

openni-primesense.x86_64: W: no-soname /usr/lib64/libXnDeviceSensorV2.so
openni-primesense.x86_64: W: no-soname /usr/lib64/libXnCore.so
openni-primesense.x86_64: W: no-soname /usr/lib64/libXnFormats.so
openni-primesense.x86_64: W: no-soname /usr/lib64/libXnDeviceFile.so
openni-primesense.x86_64: W: no-soname /usr/lib64/libXnDDK.so
- their build system does not produce soname/soversion. Will try to add something and get it accepted upstream later.

openni-primesense.x86_64: W: wrong-file-end-of-line-encoding /usr/share/doc/openni-primesense-5.0.0.25/LGPL.txt
openni-primesense.x86_64: W: wrong-file-end-of-line-encoding /usr/share/doc/openni-primesense-5.0.0.25/README
- minor

openni-primesense.x86_64: W: no-manual-page-for-binary XnSensorServer
- does not exist, but binary is usually executed automatically in the background anyway.

2 packages and 1 specfiles checked; 0 errors, 11 warnings.
Comment 1 Tim Niemueller 2011-02-02 16:57:33 EST
Oops, must be set by reviewer.
Comment 2 Rich Mattes 2011-02-02 18:51:54 EST
I will handle this review once OpenNI is approved.
Comment 3 Rich Mattes 2011-02-14 21:34:25 EST
I'm getting the following output from rpmlint:

$ rpmlint openni-primesense.spec ../RPMS/x86_64/openni-primesense-*
openni-primesense.spec: W: invalid-url Source0: openni-primesense-5.0.0.25-git894cea01.tar.gz

OK

openni-primesense.x86_64: W: incoherent-version-in-changelog 5.0.0.24-0.1gitc0e70ea1 ['5.0.0.25-0.1_git894cea01.fc14', '5.0.0.25-0.1_git894cea01']

The Release: field should read 0.1.git%{gitrev}%{?dist} and changelog entry should read 5.0.0.24-0.1.gitc0e70ea1 as per the examples given in http://fedoraproject.org/wiki/Packaging/NamingGuidelines#Pre-Release_packages (the SVN snapshots examples are most relevant here)

openni-primesense.x86_64: W: no-soname /usr/lib64/libXnDeviceSensorV2.so
openni-primesense.x86_64: W: no-soname /usr/lib64/libXnCore.so
openni-primesense.x86_64: W: no-soname /usr/lib64/libXnFormats.so
openni-primesense.x86_64: W: no-soname /usr/lib64/libXnDeviceFile.so
openni-primesense.x86_64: W: no-soname /usr/lib64/libXnDDK.so

If these are plugin libraries akin to the openni package, this should be ok.

openni-primesense.x86_64: W: wrong-file-end-of-line-encoding /usr/share/doc/openni-primesense-5.0.0.25/LGPL.txt
openni-primesense.x86_64: W: wrong-file-end-of-line-encoding /usr/share/doc/openni-primesense-5.0.0.25/README

dos2unix or sed can fix these.  

openni-primesense.x86_64: E: setuid-binary /usr/bin/XnSensorServer root 04755L
openni-primesense.x86_64: E: non-standard-executable-perm /usr/bin/XnSensorServer 04755L

Why does the sensor server binary need a setuid bit?  Device permissions should be handled by the udev rule, is there some other reason it needs to be there?

openni-primesense.x86_64: W: log-files-without-logrotate /var/log/primesense

If there are going to be logs accumulating, you should have a rule to rotate and delete them every so often.  It looks like XnSensorServer is creating a folder called XnSensorServer under /var/log/primesense, but I can't get it to add any logfiles.


openni-primesense.x86_64: W: no-manual-page-for-binary XnSensorServer

This is OK

2 packages and 1 specfiles checked; 2 errors, 11 warnings.


A few other things:

* The udev rules file mixes ATTRS and SYSFS.  SYSFS generates a lot of warning messages at bootup, you should switch to using ATTRS consistently.

* The package has a udev rule, so it needs a Requires: on udev

* LibJPEG is bundled with openni-primesense, in Source/External.  This should be removed in setup.

* The README file doesn't contain any useful end-user information, it's just instructions for building and installing.  You don't need to include it as documentation.
Comment 4 Tim Niemueller 2011-02-19 06:14:19 EST
(In reply to comment #3)
> openni-primesense.x86_64: E: setuid-binary /usr/bin/XnSensorServer root 04755L
> openni-primesense.x86_64: E: non-standard-executable-perm
> /usr/bin/XnSensorServer 04755L
> 
> Why does the sensor server binary need a setuid bit?  Device permissions should
> be handled by the udev rule, is there some other reason it needs to be there?

That is, indeed, not required anymore. Fixed, it had to be that way before I used the udev rules and I had changed that locally already.

> openni-primesense.x86_64: W: log-files-without-logrotate /var/log/primesense
> 
> If there are going to be logs accumulating, you should have a rule to rotate
> and delete them every so often.  It looks like XnSensorServer is creating a
> folder called XnSensorServer under /var/log/primesense, but I can't get it to
> add any logfiles.

I think they are overwritten, and to use them you need to configure them from your application within OpenNI. The XnSensorServer is started automatically once you request the corresponding device node.

> A few other things:
> 
> * The udev rules file mixes ATTRS and SYSFS.  SYSFS generates a lot of warning
> messages at bootup, you should switch to using ATTRS consistently.

Fixed. It's the way it came from ROS.

> * The package has a udev rule, so it needs a Requires: on udev

Done.

> * LibJPEG is bundled with openni-primesense, in Source/External.  This should
> be removed in setup.

Done. Uncovered an explicit "include <External/LibJPEG/jpeglib.h>". Really, how do companies survive that have programmers doing stuff like this, and producing code with a virtually infinite number of warnings. Well, it works nevertheless...

> * The README file doesn't contain any useful end-user information, it's just
> instructions for building and installing.  You don't need to include it as
> documentation.

Removed.

Spec file changed in place, new SRPM is at http://fedorapeople.org/~timn/robotics/openni-primesense-5.0.0.25-0.2.git894cea01.fc14.src.rpm.
Comment 5 Rich Mattes 2011-02-22 00:58:01 EST
Alright, here we go.  + is good, - is needs work, NA is not applicable.

MUST items:
[+]: rpmlint must be run on the source rpm and all binary rpms the build produces. The output should be posted in the review.

$ rpmlint openni-primesense.spec ../RPMS/x86_64/openni-primesense*
openni-primesense.spec: W: invalid-url Source0: openni-primesense-5.0.0.25-git894cea01.tar.gz
openni-primesense.x86_64: W: no-soname /usr/lib64/libXnDeviceSensorV2.so
openni-primesense.x86_64: W: no-soname /usr/lib64/libXnCore.so
openni-primesense.x86_64: W: no-soname /usr/lib64/libXnFormats.so
openni-primesense.x86_64: W: no-soname /usr/lib64/libXnDeviceFile.so
openni-primesense.x86_64: W: no-soname /usr/lib64/libXnDDK.so
openni-primesense.x86_64: W: no-manual-page-for-binary XnSensorServer
2 packages and 1 specfiles checked; 0 errors, 7 warnings.

These are all OK.

[+]: The package must be named according to the Package Naming Guidelines .
[+]: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption. 
[+]: The package must meet the Packaging Guidelines.
[+]: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines.
[+]: The License field in the package spec file must match the actual license.
[+]: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
[+]: The spec file must be written in American English. 
[+]: The spec file for the package must be legible. 
[+]: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.

OK, instructions for creating snapshot are included.

[-]: The package must successfully compile and build into binary rpms on at least one primary architecture.

Mockbuild fails with error "cannot find jpeglib.h"  You need to add BuildRequires: libjpeg-devel

[NA]: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch.
[+]: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines.
[NA]: The spec file must handle locales properly.
[+]: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun. 
[+]: Packages must NOT bundle copies of system libraries.
[NA]: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package.
[+]: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.
[+]: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)
[+]: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line.
[+]: Each package must consistently use macros. 
[+]: The package must contain code, or permissable content. 
[NA]: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity). [18]
[+]: If a package includes something as %doc, it must not affect the runtime of the application.
[NA]: Header files must be in a -devel package. 
[NA]: Static libraries must be in a -static package.
[NA]: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package. 
[NA]: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name}%{?_isa} = %{version}-%{release} 
[+]: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.
[NA]: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation. 
[+]: Packages must not own files or directories already owned by other packages.
[+]: All filenames in rpm packages must be valid UTF-8.

SHOULD items:
[NA]: If the source package does not include license text(s) as a separate file from upstream, the packager should query upstream to include it.
[NA]: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available. 
[-]: The reviewer should test that the package builds in mock.
[+]: The package should compile and build into binary rpms on all supported architectures.
[+]: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
[+]: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.
[NA]: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
[NA]: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb.
[+]: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.
[-]: your package should contain man pages for binaries/scripts. If it doesn't, work with upstream to add them where they make sense.

There's no manpage for XnSensorServer. This could be added in the future if appropriate, but is not necessary now.

All that's missing is a BuildRequires on libjpeg-devel.  Add this and I can approve the package.
Comment 6 Tim Niemueller 2011-02-26 05:05:57 EST
Spec file changed in place, new SRPM at http://fedorapeople.org/~timn/robotics/openni-primesense-5.0.0.25-0.3.git894cea01.fc14.src.rpm.
Comment 7 Rich Mattes 2011-02-26 20:38:20 EST
Great.  Mockbuild now works, this package is APPROVED.
Comment 8 Tim Niemueller 2011-02-27 03:49:17 EST
New Package SCM Request
=======================
Package Name: openni-primesense
Short Description: PrimeSensor/Kinect Modules for OpenNI
Owners: timn
Branches: f14 f15 el5 el6
InitialCC:
Comment 9 Jason Tibbitts 2011-02-28 09:57:11 EST
Git done (by process-git-requests).
Comment 10 Fedora Update System 2011-03-03 16:33:21 EST
Package openni-primesense-5.0.0.25-0.4.git894cea01.fc14:
* should fix your issue,
* was pushed to the Fedora 14 updates-testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing openni-primesense-5.0.0.25-0.4.git894cea01.fc14'
as soon as you are able to, then reboot.
Please go to the following url:
https://admin.fedoraproject.org/updates/openni-primesense-5.0.0.25-0.4.git894cea01.fc14
then log in and leave karma (feedback).
Comment 11 Fedora Update System 2011-03-03 16:38:01 EST
Package openni-primesense-5.0.0.25-0.4.git894cea01.fc15:
* should fix your issue,
* was pushed to the Fedora 15 updates-testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing openni-primesense-5.0.0.25-0.4.git894cea01.fc15'
as soon as you are able to, then reboot.
Please go to the following url:
https://admin.fedoraproject.org/updates/openni-primesense-5.0.0.25-0.4.git894cea01.fc15
then log in and leave karma (feedback).
Comment 12 Fedora Update System 2011-03-03 16:39:41 EST
Package openni-primesense-5.0.0.25-0.4.git894cea01.el6:
* should fix your issue,
* was pushed to the Fedora EPEL 6 updates-testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing openni-primesense-5.0.0.25-0.4.git894cea01.el6'
as soon as you are able to, then reboot.
Please go to the following url:
https://admin.fedoraproject.org/updates/openni-primesense-5.0.0.25-0.4.git894cea01.el6
then log in and leave karma (feedback).
Comment 13 Fedora Update System 2011-03-04 04:58:23 EST
openni-primesense-5.0.0.25-0.4.git894cea01.fc14 has been pushed to the Fedora 14 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update openni-primesense'.  You can provide feedback for this update here: https://admin.fedoraproject.org/updates/openni-primesense-5.0.0.25-0.4.git894cea01.fc14
Comment 14 Fedora Update System 2011-03-07 21:18:13 EST
openni-primesense-5.0.0.25-0.4.git894cea01.fc15 has been pushed to the Fedora 15 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 15 Fedora Update System 2011-03-17 14:53:16 EDT
openni-primesense-5.0.0.25-0.4.git894cea01.fc14 has been pushed to the Fedora 14 stable repository.
Comment 16 Fedora Update System 2011-03-18 15:26:45 EDT
openni-primesense-5.0.0.25-0.4.git894cea01.el6 has been pushed to the Fedora EPEL 6 stable repository.

Note You need to log in before you can comment on or make changes to this bug.